// import 'package:firebase_storage_hooks/src/models/file_handler.dart';
// import 'package:flutter/material.dart';
// import 'package:flutter_hooks/flutter_hooks.dart';
// import 'package:image_picker/image_picker.dart';

// /// Uses `file_picker` to pick a file and returns that file as [XFile].
// /// Loading, error and data states are handled through the [AsyncSnapshot] type.
// FileHandler<XFile> useImage({
//   required ImageSource source,
//   double? maxWidth,
//   double? maxHeight,
//   int? imageQuality,
//   CameraDevice preferredCameraDevice = CameraDevice.rear,
// }) {
//   final imagePicker = useMemoized(() => ImagePicker());
//   final imageResult = useState<XFile?>(null);
//   final isLoading = useState<bool>(false);
//   final error = useState<Object?>(null);
//   final stackTrace = useState<StackTrace?>(null);
//   final isMounted = useIsMounted();

//   void clearError() {
//     error.value = null;
//     stackTrace.value = null;
//   }

//   final _error = error.value;
//   final _stackTrace = stackTrace.value;

//   Future<XFile?> select() async {
//     clearError();
//     isLoading.value = true;

//     try {
//       final result = await imagePicker.pickImage(
//         source: source,
//         maxWidth: maxWidth,
//         maxHeight: maxHeight,
//         imageQuality: imageQuality,
//         preferredCameraDevice: preferredCameraDevice,
//       );

//       if (result != null && isMounted()) {
//         imageResult.value = result;

//         return result;
//       }
//     } catch (_error, _stackTrace) {
//       error.value = _error;
//       stackTrace.value = _stackTrace;
//       rethrow;
//     } finally {
//       if (isMounted()) {
//         isLoading.value = false;
//       }
//     }
//   }

//   final filePickerValue = imageResult.value;
//   final AsyncSnapshot<XFile> snapshot;

//   if (isLoading.value) {
//     snapshot = const AsyncSnapshot<XFile>.waiting();
//   } else if (filePickerValue != null) {
//     snapshot = AsyncSnapshot<XFile>.withData(
//       ConnectionState.done,
//       filePickerValue,
//     );
//   } else if (_error != null && _stackTrace != null) {
//     snapshot = AsyncSnapshot<XFile>.withError(
//       ConnectionState.done,
//       _error,
//       _stackTrace,
//     );
//   } else {
//     assert(_error == null && _stackTrace == null);
//     snapshot = const AsyncSnapshot<XFile>.nothing();
//   }

//   return FileHandler(
//     select: select,
//     snapshot: snapshot,
//   );
// }
