import 'package:flutter/foundation.dart';

typedef RetryFailed = Future<void> Function();

/// An interface that both exposes a value of a commit and a function to revert
/// the commit.
@immutable
class CommitHandler<T extends Object> {
  const CommitHandler({
    required this.value,
    required this.revert,
  });

  final T value;

  /// This function will undo the commit operation so long as it maintains
  /// its lifetime.
  final AsyncCallback revert;
}
