import 'package:firebase_storage_hooks/src/models/commit_handler.dart';
import 'package:flutter/foundation.dart';

/// An interface that both exposes a value of a commit and a function to revert
/// the commit.
@immutable
class CommitsHandler<T extends Object> {
  const CommitsHandler({
    required this.values,
    required this.revert,
    required this.retryFailed,
  });

  final List<T> values;

  /// This function will undo the commit operation so long as it maintains
  /// its lifetime.
  final AsyncCallback revert;

  final RetryFailed retryFailed;
}
