import 'package:flutter/foundation.dart';

/// Contains information about the async operation.
@immutable
class ProgressInformation {
  const ProgressInformation({
    required this.totalBytes,
    required this.bytesTransferred,
  }) : assert(totalBytes != 0);

  final int totalBytes;

  final int bytesTransferred;

  double get progress => (bytesTransferred / totalBytes) * 100;
}
